<?php session_start();
date_default_timezone_set('America/Bogota');
//RESTRICCI�N DE ACCESO A TRABAJADOR (ACCESO INDIVIDUAL)
if (isset($_SESSION['tipousuario']))
		{if ($_SESSION['tipousuario']=='1')
		header ('location:menu_personal.php');
		}
if  (trim($_SESSION['nombre_validar'])=='') header ('location:index.php');
include ("fphp.php");
$enlace=cargar_conexion();
$detalle=$_REQUEST["detalle"];
$pago=$_REQUEST["pago"];


		
		
		//Consulta empleados a pagar
		//$query_emp_pagar = "SELECT ut.*, ut.cedula, SUM(if(ut.tipo = 'A', ut.monto, if(ut.tipo = 'D', (-1) * ut.monto, 0))) AS monto, CONCAT (pe.nombres, ' ', pe.apellidos) as nombres, pe.cuenta,pe.tipo, pe.mensaje, pe.nacionalidad FROM utilidades AS ut INNER JOIN personal AS pe ON ut.cedula = pe.codigo WHERE ut.id = '".$_SESSION['id_validar']."' AND ut.fecha = '".$pago."' AND ut.detalle = '".$detalle."' GROUP BY ut.cedula order by pe.codigo";

	 	//$resul_emp_pagar = mysqli_query($enlace,$query_emp_pagar);
		//$cant_emp_pagar = mysqli_num_rows($resul_emp_pagar);
		//$row_monto=mysqli_fetch_array($resul_emp_pagar);
		



		//$fecha_lote = date("jnY"); //Fecha a imprimir en archivo (Fecha sin ceros a la izquierda)
		//$numero_lote_archivo = rand(1000000,9999999); //Número aleatorio
		//$numero_serie = rand(100000,999999)+100000;



if ($_SESSION['id_validar']==104 || $_SESSION['id_validar']==107){ ////MERSAN
	//Generación de archivo
    $f = "BancoMercantil/utilidades-".$fecha_lote.".txt";
    $file = fopen($f,"w+");
	
		////////////Inica BNC
	$consultaEmpresa="select nombre,encabeza from empresa where id='".$_SESSION['id_validar']."' ";
			$consultaEmpresa=mysqli_query($enlace,$consultaEmpresa) or die ($consultaEmpresa.mysqli_error($enlace));
			$rowEmpresa = mysqli_fetch_array($consultaEmpresa);
			$nombreEmpresa = $rowEmpresa['nombre'];
			$rifEmpresa   = $rowEmpresa['encabeza'];
			$rifEmpresa = preg_replace('([^A-Za-z0-9])', '', $rifEmpresa);
			
			//Consulta monto total a pagar
		$query_monto_pagar = "SELECT SUM(if(tipo = 'A', monto, if(tipo = 'D', (-1) * monto, 0))) AS monto FROM utilidades WHERE fecha = '".$pago."' AND detalle = '".$detalle."' AND id = '".$_SESSION['id_validar']."' ";
	 	$resul_monto_pagar = mysqli_query($enlace,$query_monto_pagar);
		$row_monto=mysqli_fetch_array($resul_monto_pagar);
		$tmonto = str_replace('.','',$row_monto['monto']); //Monto total a pagar, se le quita el signo punto

			
			$queryx="SELECT per.tipo AS tipo_cuenta, ut.tipo AS tipo_concepto, SUM(ut.monto) as monto, ut.cedula, per.banco, ut.detalle, per.nombres, per.apellidos, per.cuenta, per.nacionalidad, per.mensaje FROM personal AS per, utilidades AS ut 
			WHERE per.id = '".$_SESSION['id_validar']."'  AND ut.tipo <> 'R' 
			AND ut.cedula = per.codigo AND ut.id = '".$_SESSION['id_validar']."' AND ut.fecha = '".$pago."' AND ut.detalle = '".$detalle."'  GROUP BY ut.cedula, tipo_concepto order by ut.cedula, ut.concepto, ut.desconcepto";
			
			$consulta=mysqli_query($enlace,$queryx) or die ($queryx.mysqli_error($enlace));
			$cant_emp_pagar = mysqli_num_rows($consulta);

			$total_pagar=0;$asignaciones=0;$deducciones=0;

			while($rows_reporte=mysqli_fetch_array($consulta)){
			$array_reg[] = $rows_reporte;
			}
			$fecha_pago = date('d/m/y');
			$nombre_archivo = "bancos.txt";
			$file = fopen($nombre_archivo, "w+");
			fwrite($file, "ND");
			fwrite($file, " ");
			
			if($_SESSION['id_validar']==104){///MERSAN
				fwrite($file, "01910085532185049069");
			}elseif ($_SESSION['id_validar']==107){///IGM
				fwrite($file, "01910085562185137626");
				}

			fwrite($file, str_repeat("0",13-strlen($tmonto)));
			fwrite($file, $tmonto);
			fwrite($file, $rifEmpresa);
			fwrite($file, "\r\n"); //Nueva Linea

			for($i=0;$i<count($array_reg);$i++){
				$cedula = $array_reg[$i]['cedula'];
				$nombres = $array_reg[$i]['nombres'];
				$apellidos = $array_reg[$i]['apellidos'];
				$nacionalidad = $array_reg[$i]['nacionalidad'];
				$mensaje = $array_reg[$i]['mensaje'];
				$cuenta = $array_reg[$i]['cuenta'];
				$tipo_cuenta = $array_reg[$i]['tipo_cuenta'];
				$tipo_cuenta = $tipo_cuenta-1;//este -1 es para que coincida con el tipo de cuenta del txt banco Vzla qu es cta-crrte=1 y cta-ahorr=0--Miguelangel
				$banco = $array_reg[$i]['banco'];
				$desperiodo = $array_reg[$i]['desperiodo'];
				$tipo_concepto = $array_reg[$i]['tipo_concepto'];
				$monto = $array_reg[$i]['monto'];

				if ($tipo_concepto == 'A'){
					$asignaciones+= $monto;
				}else if ($tipo_concepto == 'D'){
					$deducciones+= $monto;
				}

				$total_pagar = $asignaciones - $deducciones;

				if($array_reg[$i]['cedula']!=$array_reg[$i+1]['cedula']){ //Si el siguiente registro es de otra persona, entonces imprime

					//
					if ($total_pagar != 0){
						$total_pagar = str_replace(".","",number_format($total_pagar,2,'.','')); //Formateo monto a pagar pa

						//Inicia a imprimir

						fwrite($file, "NC");
						fwrite($file, " ");
						fwrite($file, str_pad($cuenta, 20, "0", STR_PAD_LEFT));
						fwrite($file, str_pad($total_pagar, 13, "0", STR_PAD_LEFT));
						fwrite($file, $nacionalidad);
						fwrite($file, str_pad($cedula, 9, "0", STR_PAD_LEFT));
						
						fwrite($file, "\r\n"); //Nueva Linea


						//echo str_pad($nombres." ".$apellidos, 35, &nbsp;, STR_PAD_RIGHT); //Imprime nombres con espacios hasta 50 caracteres
	 				  //echo "\r\n"; //Nueva linea
						//echo "<br>";
						$total_pagar = 0; $asignaciones = 0;  $deducciones =0; //Limpia variables
					}
				}
			}
			fclose($file);

			header('Content-Description: File Transfer');
	    header('Content-Disposition: attachment; filename=' . $nombre_archivo);
	    header('Expires: 0');
	    header('Cache-Control: must-revalidate');
	    header('Pragma: public');
	    header('Content-Length: ' . filesize($nombre_archivo));
			readfile($nombre_archivo);
			unlink($nombre_archivo);


		 	if (count($array_reg)==0){
				echo "<font color=#DD0044 size=3>**** Banco No posee definici&oacute;n de Archivo Texto...... LLame a CONSULTARH *****</font>";
			}
			
				
   
		 ///////FIN pago de banco BNC
	
	
	}	elseif ($_SESSION['id_validar']==105 ){ ////FINTECH
		$consultaEmpresa="select nombre from empresa where id='".$_SESSION['id_validar']."' ";
		$consultaEmpresa=mysqli_query($enlace,$consultaEmpresa) or die ($consultaEmpresa.mysqli_error($enlace));
		$rowEmpresa = mysqli_fetch_array($consultaEmpresa);
		$nombreEmpresa=$rowEmpresa['nombre'];
		////////////////**************************************

		$fecha_pago = date('d/m/y');
		$nombre_archivo = "bancos.txt";
		//$file = fopen($nombre_archivo, "w+");
		fwrite($file, "H");
		fwrite($file, $nombreEmpresa);
		fwrite($file, str_repeat(" ",40-strlen($nombreEmpresa)));
		fwrite($file, "01020759250000054933");
		fwrite($file, "08");
		fwrite($file, $fecha_pago);
		fwrite($file, str_repeat("0",13-strlen($monto_total_pagar)));
		fwrite($file, $monto_total_pagar);
		fwrite($file, "03291");
		fwrite($file, " ");

		fwrite($file, "\r\n");
				//REGISTRO: SEGUNDA LINEA //

				while ($row_emp_pag=mysqli_fetch_array($resul_emp_pagar)){
					$cedula = $row_emp_pag['cedula'];
					$monto = str_replace('.','',$row_emp_pag['monto']); //Monto total a pagar, se le quita el signo punto
					$concepto_monto = $row_emp_pag['concepto'];
					$cuenta_banco = $row_emp_pag['cuenta'];
					$tipo_cuenta = $row_emp_pag['tipo'];
					$tipo_cuenta = $tipo_cuenta - 1 ; ////para coincidir con el tipo en el txt ahorros=0, corriente = 1 Miguelangel
					$nacionalidad = $row_emp_pag['nacionalidad'];
					$nombres = preg_replace("/\s+/", " ", trim($row_emp_pag['nombres']));
					$correo = $row_emp_pag['mensaje'];
					$nomina = $row_emp_pag['nomina'];

					//fwrite($file,"2V"); //Constante

					//fwrite($file,"1000000000000               000000000000000"); //Constante
					fwrite($file,$tipo_cuenta);
					fwrite($file,str_pad($cuenta_banco, 20, "0", STR_PAD_LEFT)); //Número de cuenta
					fwrite($file, str_pad($monto, 11, "0", STR_PAD_LEFT));
					fwrite($file,$tipo_cuenta);
					fwrite($file, "770");
					fwrite($file,str_pad($nombres, 40, " ", STR_PAD_RIGHT));
					fwrite($file,str_pad($cedula, 10, "0", STR_PAD_LEFT)); //Número de cedula
					fwrite($file, "003291");
					fwrite($file, "  ");

					fwrite($file,"\r\n"); //Nueva Linea

				}

		    fclose($file);
		    //fclose($fileOtros);
					
    echo "<style>
    .regristrado{
        color: green;
        margin-left: 7%;
        font-weight: bold;
    }
    </style>";
    echo "<p class='regristrado' >Archivo guardado correctamente<p>";
    echo "<script>
        window.location.href = 'generar_txt.php?fileUtiliBank=$f';
        </script>";
		
	}elseif ($_SESSION['id_validar']==106 ){ ///GSC PROVINCIAL
		//////////pago de banco provincial a trabajadores con cualquier banco

			$queryx="SELECT per.tipo AS tipo_cuenta, ut.tipo AS tipo_concepto, SUM(ut.monto) as monto, ut.cedula, per.banco, ut.detalle, per.nombres, per.apellidos, per.cuenta, per.nacionalidad, per.mensaje FROM personal AS per, utilidades AS ut 
			WHERE per.id = '".$_SESSION['id_validar']."'  AND ut.tipo <> 'R' 
			AND ut.cedula = per.codigo AND ut.id = '".$_SESSION['id_validar']."' AND ut.fecha = '".$pago."' AND ut.detalle = '".$detalle."'  GROUP BY ut.cedula, tipo_concepto order by ut.cedula, ut.concepto, ut.desconcepto";
			$consulta=mysqli_query($enlace,$queryx) or die ($queryx.mysqli_error($enlace));
			$cant_emp_pagar = mysqli_num_rows($consulta);

			$total_pagar=0;$asignaciones=0;$deducciones=0;

			while($rows_reporte=mysqli_fetch_array($consulta)){
				$array_reg[] = $rows_reporte;
			}

			$nombre_archivo = "bancos.txt";
			$file = fopen($nombre_archivo, "w+");


			for($i=0;$i<count($array_reg);$i++){
				$cedula = $array_reg[$i]['cedula'];
				$nombres = $array_reg[$i]['nombres'];
				$apellidos = $array_reg[$i]['apellidos'];
				$nacionalidad = $array_reg[$i]['nacionalidad'];
				$mensaje = $array_reg[$i]['mensaje'];
				$cuenta = $array_reg[$i]['cuenta'];
				$tipo_cuenta = $array_reg[$i]['tipo_cuenta'];
				$banco = $array_reg[$i]['banco'];
				$desperiodo = $array_reg[$i]['desperiodo'];
				$tipo_concepto = $array_reg[$i]['tipo_concepto'];
				$monto = $array_reg[$i]['monto'];

				if ($tipo_concepto == 'A'){
					$asignaciones+= $monto;
				}else if ($tipo_concepto == 'D'){
					$deducciones+= $monto;
				}

				$total_pagar = $asignaciones - $deducciones;

				if($array_reg[$i]['cedula']!=$array_reg[$i+1]['cedula']){ //Si el siguiente registro es de otra persona, entonces imprime

					if ($total_pagar != 0){
						$total_pagar = str_replace(".","",number_format($total_pagar,2,'.','')); //Formateo monto a pagar

						//Inicia a imprimir
						fwrite($file, str_pad($cuenta, 20, "0", STR_PAD_LEFT));
						fwrite($file, str_pad("", 1, " ", STR_PAD_RIGHT));
						fwrite($file, $nacionalidad);
						fwrite($file, str_pad($cedula, 10, "0", STR_PAD_LEFT));
						fwrite($file, str_pad("", 1, " ", STR_PAD_RIGHT));
				 		fwrite($file, str_pad($total_pagar, 15, "0", STR_PAD_LEFT));
						fwrite($file, str_pad("", 1, " ", STR_PAD_RIGHT));
						fwrite($file, str_pad($nombres." ".$apellidos, 35, " ", STR_PAD_RIGHT)); //Imprime nombres con espacios hasta 60 caracteres
						fwrite($file, "\r\n"); //Nueva Linea


						//echo str_pad($nombres." ".$apellidos, 35, &nbsp;, STR_PAD_RIGHT); //Imprime nombres con espacios hasta 50 caracteres
	 				  //echo "\r\n"; //Nueva linea
						//echo "<br>";
						$total_pagar = 0; $asignaciones = 0;  $deducciones =0; //Limpia variables
					}
				}
			}
			fclose($file);

			header('Content-Description: File Transfer');
	    header('Content-Disposition: attachment; filename=' . $nombre_archivo);
	    header('Expires: 0');
	    header('Cache-Control: must-revalidate');
	    header('Pragma: public');
	    header('Content-Length: ' . filesize($nombre_archivo));
			readfile($nombre_archivo);
			unlink($nombre_archivo);


		 	if (count($array_reg)==0){
				echo "<font color=#DD0044 size=3>**** Banco No posee definici&oacute;n de Archivo Texto...... LLame a CONSULTARH *****</font>";
			}
		
	}
		
		
		
		
		
?>